> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Exchange Token

> Exchanges an exchange token for a new access token.

`Unary` · [`Identity`](https://ona.com/docs/api-reference/generated/identity/overview)

Exchanges an exchange token for a new access token.

Use this method to:

* Convert exchange tokens to access tokens
* Obtain new access credentials
* Complete token exchange flows

### Examples

* Exchange token:

  Trades an exchange token for an access token.

  ```yaml theme={null}
  exchangeToken: "exchange-token-value"
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.IdentityService/ExchangeToken
```

Send a Bearer token as described in [Authentication](https://ona.com/docs/api-reference.md#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

```bash cURL theme={null}
export ONA_HOST=https://app.ona.com
export ONA_API_KEY=<your-token>

curl --request POST \
  --url "$ONA_HOST/api/gitpod.v1.IdentityService/ExchangeToken" \
  --header "Authorization: Bearer $ONA_API_KEY" \
  --header "Content-Type: application/json" \
  --data '{
  "exchangeToken": "<redacted>"
}'
```

```python Python theme={null}
import gitpod.v1.identity_pb2 as identity_pb2
from ona_sdk import create_client_from_env

ona = create_client_from_env()
request = identity_pb2.ExchangeTokenRequest(
    exchange_token="<redacted>",
)
response = ona.services.identity.exchange_token(request)
print(response)
```

```typescript TypeScript theme={null}
import { create } from "@bufbuild/protobuf";
import { createClientFromEnv } from "@gitpod/sdk";
import { ExchangeTokenRequestSchema } from "@gitpod/sdk/gitpod/v1/identity_pb";

async function main() {
  const ona = createClientFromEnv();
  const request = create(ExchangeTokenRequestSchema, {
    exchangeToken: "<redacted>",
  });
  const response = await ona.services.identity.exchangeToken(request);
  console.log(response);
}

main().catch(console.error);
```

```go Go theme={null}
package main

import (
	"context"
	"fmt"
	"log"

	"connectrpc.com/connect"
	"github.com/gitpod-io/gitpod-sdk-go/sdk"
	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
)

func main() {
	ona, err := sdk.NewFromEnv()
	if err != nil {
		log.Fatal(err)
	}

	request := connect.NewRequest(&gitpodpb.ExchangeTokenRequest{
		ExchangeToken: "<redacted>",
	})
	response, err := ona.Services.Identity.ExchangeToken(context.Background(), request)
	if err != nil {
		log.Fatal(err)
	}
	fmt.Println(response.Msg)
}
```

```json Request body theme={null}
{
  "exchangeToken": "<redacted>"
}
```

## Request

`gitpod.v1.ExchangeTokenRequest`

| Field | Type | Required | Description |
| - | - | - | - |
| `exchangeToken` | string | No | exchange\_token is the token to exchange |

## Response

`gitpod.v1.ExchangeTokenResponse`

| Field | Type | Required | Description |
| - | - | - | - |
| `accessToken` | string | No | access\_token is the new access token |


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.